#ifndef LISTS_H
#define LISTS_H

#include <malloc.h>

/*****************************************************************************/

#define NULL_KEY -1

/*****************************************************************************/

typedef int KEY_TYPE;

/*****************************************************************************/

struct list_node {
	KEY_TYPE key_code;
	struct list_node *next;
	struct list_node *previous;
};

typedef struct list_node LIST_NODE;
typedef struct list_node * LIST_NODEPTR;

struct list {
	LIST_NODEPTR HEAD;
	LIST_NODEPTR NIL;
	int NUMBER_OF_ELEMENTS;
};

typedef struct list LIST;
typedef struct list * LISTPTR;

/*****************************************************************************/

/* Necessary Initializations */
LISTPTR LIST__Initialize ();
/* List's Search Operation */
LIST_NODEPTR LIST__Search (LISTPTR, KEY_TYPE);
/* Insert node at front - Do not allow duplicate insertions according to key */
int LIST__Insert_node_at_front (LISTPTR, KEY_TYPE);
/* Search List for a node with KEY == key and if found, delete it. */
int LIST__Delete_node_according_to_key (LISTPTR, KEY_TYPE);
/* Delete a specific node in list. */
int LIST__Delete_node (LISTPTR, LIST_NODEPTR);
/* Destroy List */
int LIST__Destroy (LISTPTR);
/* Swap Nodes in List */
int LIST__Swap_nodes (LISTPTR, LIST_NODEPTR, LIST_NODEPTR);

/*****************************************************************************/

#endif
