#ifndef MORET_H
#define MORET_H

#define HURDLE          1
#define GREATHURDLE (1<<1)
#define SUPERHURDLE (1<<2)
#define TRUE            1
#define FALSE           0

/*******************************************************************/

typedef struct {
  int index;    /* index of component's root */
  int oriented; /* Boolean: Is component oriented */
  int blocks;   /* Number of blocks in nonoriented component */
  int hurdle;   /* Bitmask of HURDLE properties.
		   Bit 0 = hurdle
		   Bit 1 = wrap-around hurdle
		   Bit 2 = superhurdle */
  int left;     /* Index of component to the left of my rightmost block */
  int right;    /* Index of component to the right of my rightmost block */
} component_t;

typedef struct {
  int *perm;
  int *done;
  int *greyEdges;

  int *stack;      /* DIST_INV: size */
  int *oriented;
  int *cc;
  int *labeled;
  component_t *components;
} distmem_t;

/*******************************************************************/

void connected_component(int,distmem_t *, int *);

/*******************************************************************/

#endif
